Scriptname aaaSusanoAbility extends activemagiceffect  
{This will make the damage taken to be transfered to Magicka. When out of Magicka, it will dispel Susano'o.}
;======================================================================================;
;  MISCELLANEOUS PROPERTIES
;=============;
ARMOR Property dunRatwayBrawlerGloves Auto
GLOBALVARIABLE Property aaaSusanooTransitionGlobal Auto
PERK Property EMSPerk Auto
PERK Property Overdraw00 Auto
PERK Property Overdraw20 Auto
PERK Property Overdraw40 Auto
PERK Property Overdraw60 Auto
PERK Property Overdraw80 Auto
PERK Property DevastatingBlow Auto
PERK Property SavageStrike Auto
PERK Property DualSavagery Auto
Race Property KhajiitRace Auto
Race Property KhajiitRaceVampire Auto
Race Property ArgonianRace Auto
Race Property ArgonianRaceVampire Auto
Race Property DLC1VampireBeastRace Auto
SPELL Property aaaSusanoStage1Spell Auto
SPELL Property aaaSusanoStage2Spell Auto
SPELL Property aaaSusanoStage3Spell Auto
SPELL Property aaaSusanoStage4Spell Auto

;======================================================================================;
;  KEYWORDS
;=============;
KEYWORD Property SwordKeyword Auto
KEYWORD Property GreatswordKeyword Auto
KEYWORD Property BattleaxeKeyword Auto
KEYWORD Property WarhammerKeyword Auto
KEYWORD Property WaraxeKeyword Auto
KEYWORD Property MaceKeyword Auto
KEYWORD Property DaggerKeyword Auto
KEYWORD Property BowKeyword Auto
KEYWORD Property ArrowKeyword Auto
KEYWORD Property BoundArrowKeyword Auto
KEYWORD Property MagicDamageFire Auto
KEYWORD Property MagicDamageFrost Auto
KEYWORD Property MagicDamageShock Auto

;======================================================================================;
;  VARIABLES
;=============;
ACTOR akAttacker
FLOAT Base_Damage
FLOAT BonusPugilist
FLOAT TotalUnarmedBonus
FLOAT Smithing_Increase
FLOAT PerkRankLevel
FLOAT Perk_Effects
FLOAT Displayed_Damage
FLOAT DualPowerAttackBonus
FLOAT PowerAttackPerk
FLOAT DualPowerAttackPerk
FLOAT Damage
FLOAT SusanooFactor
FLOAT Property SusanooFactorStage1 Auto
FLOAT Property SusanooFactorStage2 Auto
FLOAT Property SusanooFactorStage3 Auto
FLOAT Property SusanooFactorStage4 Auto
FLOAT IntermediateDamage
FLOAT BowBaseDamage
FLOAT ArrowBaseDamage
FLOAT BonusSmithing
FLOAT Skill
INT PowerAttackBonus
SPELL akSpell
WEAPON akWeapon
WEAPON akFists
WEAPON akBow

;======================================================================================;
;  EVENTS
;=============;
Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack,  bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
If(akAggressor != Game.GetPlayer())
;======================================================================================;
;  MELEE WEAPONS - UNARMED
;=============;
	akFists = akSource as Weapon
	If(akFists.GetWeaponType() == 0 && akSource.GetType() != 22 && akSource.GetType() != 82)
		akAttacker = akAggressor as Actor
		Armor Gloves = akAttacker.GetWornForm(0x00000008) as Armor
		If(aaaSusanooTransitionGlobal.GetValue() == 1)
			SusanooFactor = SusanooFactorStage3
		ElseIf(aaaSusanooTransitionGlobal.GetValue() == 2)
			SusanooFactor = SusanooFactorStage2
		ElseIf(aaaSusanooTransitionGlobal.GetValue() == 3)
			SusanooFactor = SusanooFactorStage1
		ElseIf(aaaSusanooTransitionGlobal.GetValue() == 4)
			SusanooFactor = SusanooFactorStage4
		EndIf

		; ***** CHECK FOR POSSIBLE BONUSES *****
		If(Gloves == dunRatwayBrawlerGloves)
			BonusPugilist = 10
		Else
			BonusPugilist = 0
		EndIf
		TotalUnarmedBonus = BonusPugilist

		; ***** ADJUST DAMAGE FOR RACE *****
		If(akAttacker.GetRace() == KhajiitRace || akAttacker.GetRace() == KhajiitRaceVampire)
			IntermediateDamage = (25 + TotalUnarmedBonus) * SusanooFactor
		ElseIf(akAttacker.GetRace() == ArgonianRace || akAttacker.GetRace() == ArgonianRaceVampire)
			IntermediateDamage = (20 + TotalUnarmedBonus) * SusanooFactor
		ElseIf(akAttacker.GetRace() == DLC1VampireBeastRace)
			IntermediateDamage = (akAttacker.GetAV("UnarmedDamage") + 15 + TotalUnarmedBonus) * SusanooFactor
		Else
			IntermediateDamage = (akAttacker.GetAV("UnarmedDamage") + TotalUnarmedBonus) * SusanooFactor
		EndIf
		INT FinalDamage = Math.Ceiling(IntermediateDamage as FLOAT)
		If(Game.GetPlayer().GetAV("Magicka") > FinalDamage)
			Game.GetPlayer().DamageAV("Magicka", FinalDamage)
		Else
			Game.GetPlayer().DamageAV("Magicka", Game.GetPlayer().GetAV("Magicka"))
			If(aaaSusanooTransitionGlobal.GetValue() == 1)
				aaaSusanoStage1Spell.Cast(Game.GetPlayer(), none)
			ElseIf(aaaSusanooTransitionGlobal.GetValue() == 2)
				aaaSusanoStage2Spell.Cast(Game.GetPlayer(), none)
			ElseIf(aaaSusanooTransitionGlobal.GetValue() == 3)
				aaaSusanoStage3Spell.Cast(Game.GetPlayer(), none)
			ElseIf(aaaSusanooTransitionGlobal.GetValue() == 4)
				aaaSusanoStage4Spell.Cast(Game.GetPlayer(), none)
			EndIf
		EndIf
;======================================================================================;
;  MELEE WEAPONS - CLOSE RANGE
;=============;
	ElseIf(akSource.HasKeyword(SwordKeyword) || akSource.HasKeyword(GreatswordKeyword) || akSource.HasKeyword(BattleaxeKeyword) || akSource.HasKeyword(WarhammerKeyword) || akSource.HasKeyword(WaraxeKeyword) || akSource.HasKeyword(MaceKeyword) || akSource.HasKeyword(DaggerKeyword))
		; ***** VARIABLES *****
		akWeapon = akSource as Weapon
		akAttacker = akAggressor as Actor

		; ***** DISPLAYED DAMAGE *****
		Base_Damage = akWeapon.GetBaseDamage()
		Smithing_Increase = 0.2
		If(akAttacker.GetActorValue("OneHanded") >= akAttacker.GetActorValue("TwoHanded"))
			Skill = akAttacker.GetActorValue("OneHanded")
		Else
			Skill = akAttacker.GetActorValue("TwoHanded")
		EndIf
		If(akAttacker.GetActorValue("OneHanded") >= akAttacker.GetActorValue("TwoHanded"))
			If(akAttacker.GetActorValue("OneHanded") < 20)
				PerkRankLevel = 1
			ElseIf(akAttacker.GetActorValue("OneHanded") >= 20 && akAttacker.GetActorValue("OneHanded") < 40)
				PerkRankLevel = 2
			ElseIf(akAttacker.GetActorValue("OneHanded") >= 40 && akAttacker.GetActorValue("OneHanded") < 60)
				PerkRankLevel = 3
			ElseIf(akAttacker.GetActorValue("OneHanded") >= 60 && akAttacker.GetActorValue("OneHanded") < 80)
				PerkRankLevel = 4
			ElseIf(akAttacker.GetActorValue("OneHanded") >= 80)
				PerkRankLevel = 5
			EndIf
		Else
			If(akAttacker.GetActorValue("TwoHanded") < 20)
				PerkRankLevel = 1
			ElseIf(akAttacker.GetActorValue("TwoHanded") >= 20 && akAttacker.GetActorValue("TwoHanded") < 40)
				PerkRankLevel = 2
			ElseIf(akAttacker.GetActorValue("TwoHanded") >= 40 && akAttacker.GetActorValue("TwoHanded") < 60)
				PerkRankLevel = 3
			ElseIf(akAttacker.GetActorValue("TwoHanded") >= 60 && akAttacker.GetActorValue("TwoHanded") < 80)
				PerkRankLevel = 4
			ElseIf(akAttacker.GetActorValue("TwoHanded") >= 80)
				PerkRankLevel = 5
			EndIf
		EndIf
		Perk_Effects = 0.2 * PerkRankLevel
		Displayed_Damage = (Base_Damage + Smithing_Increase) * (1 + 0.5 * Skill/100) * (1 + Perk_Effects)

		; ***** REMAINING INPUTS *****
		If(abPowerAttack == true)
			PowerAttackBonus = 1
		Else
			PowerAttackBonus = 0
		EndIf
		If((akWeapon.GetWeaponType() == 5 || akWeapon.GetWeaponType() == 6) && abPowerAttack == true)
			DualPowerAttackBonus = 0.125
		Else
			DualPowerAttackBonus = 0
		EndIf
		If((akAttacker.HasPerk(SavageStrike) || akAttacker.HasPerk(DevastatingBlow)) && abPowerAttack == true)
			PowerAttackPerk = 0.25
		Else
			PowerAttackPerk = 0
		EndIf
		If((akWeapon.GetWeaponType() == 5 || akWeapon.GetWeaponType() == 6) && abPowerAttack == true && akAttacker.HasPerk(DualSavagery))
			DualPowerAttackPerk = 0.5
		Else
			DualPowerAttackPerk = 0
		EndIf

		; ***** DAMAGE FINAL COUNT + DAMAGE THE PLAYER *****
		Damage = (Displayed_Damage * (1 + PowerAttackBonus) * (1 + DualPowerAttackBonus) * (1 + PowerAttackPerk) * (1 + DualPowerAttackPerk))
		If(aaaSusanooTransitionGlobal.GetValue() == 1)
			SusanooFactor = SusanooFactorStage3
		ElseIf(aaaSusanooTransitionGlobal.GetValue() == 2)
			SusanooFactor = SusanooFactorStage2
		ElseIf(aaaSusanooTransitionGlobal.GetValue() == 3)
			SusanooFactor = SusanooFactorStage1
		ElseIf(aaaSusanooTransitionGlobal.GetValue() == 4)
			SusanooFactor = SusanooFactorStage4
		EndIf
		IntermediateDamage = Damage * SusanooFactor
		INT FinalDamage = Math.Ceiling(IntermediateDamage as FLOAT)
		If(Game.GetPlayer().GetAV("Magicka") > FinalDamage)
			Game.GetPlayer().DamageAV("Magicka", FinalDamage)
		Else
			Game.GetPlayer().DamageAV("Magicka", Game.GetPlayer().GetAV("Magicka"))
			If(aaaSusanooTransitionGlobal.GetValue() == 1)
				aaaSusanoStage1Spell.Cast(Game.GetPlayer(), none)
			ElseIf(aaaSusanooTransitionGlobal.GetValue() == 2)
				aaaSusanoStage2Spell.Cast(Game.GetPlayer(), none)
			ElseIf(aaaSusanooTransitionGlobal.GetValue() == 3)
				aaaSusanoStage3Spell.Cast(Game.GetPlayer(), none)
			ElseIf(aaaSusanooTransitionGlobal.GetValue() == 4)
				aaaSusanoStage4Spell.Cast(Game.GetPlayer(), none)
			EndIf
		EndIf
;======================================================================================;
;  MELEE WEAPONS - LONG RANGE
;=============;
	ElseIf(akSource.HasKeyword(BowKeyword) || akSource.HasKeyword(ArrowKeyword) || akSource.HasKeyword(BoundArrowKeyword))
		; ***** VARIABLES *****
		akAttacker = akAggressor as Actor
		akBow = akAttacker.GetEquippedWeapon() as Weapon

		; ***** NECESSARY INPUTS *****
		BowBaseDamage = akAttacker.GetEquippedWeapon().GetBaseDamage()
		ArrowBaseDamage = 20
		BonusSmithing = 0.2
		Skill = akAttacker.GetActorValue("Marksman")
		If(akAttacker.GetActorValue("Marksman") < 20)
			PerkRankLevel = 1
		ElseIf(akAttacker.GetActorValue("Marksman") >= 20 && akAttacker.GetActorValue("Marksman") < 40)
			PerkRankLevel = 2
		ElseIf(akAttacker.GetActorValue("Marksman") >= 40 && akAttacker.GetActorValue("Marksman") < 60)
			PerkRankLevel = 3
		ElseIf(akAttacker.GetActorValue("Marksman") >= 60 && akAttacker.GetActorValue("Marksman") < 80)
			PerkRankLevel = 4
		ElseIf(akAttacker.GetActorValue("Marksman") >= 80)
			PerkRankLevel = 5
		EndIf

		; ***** DAMAGE FINAL COUNT + DAMAGE THE PLAYER *****
		Damage = (BowBaseDamage + ArrowBaseDamage + BonusSmithing) * (1 + Skill/200) * (1 + PerkRankLevel)
		If(aaaSusanooTransitionGlobal.GetValue() == 1)
			SusanooFactor = SusanooFactorStage3
		ElseIf(aaaSusanooTransitionGlobal.GetValue() == 2)
			SusanooFactor = SusanooFactorStage2
		ElseIf(aaaSusanooTransitionGlobal.GetValue() == 3)
			SusanooFactor = SusanooFactorStage1
		ElseIf(aaaSusanooTransitionGlobal.GetValue() == 4)
			SusanooFactor = SusanooFactorStage4
		EndIf
		IntermediateDamage = Damage * SusanooFactor
		INT FinalDamage = Math.Ceiling(IntermediateDamage as FLOAT)
		If(Game.GetPlayer().GetAV("Magicka") > FinalDamage)
			Game.GetPlayer().DamageAV("Magicka", FinalDamage)
		Else
			Game.GetPlayer().DamageAV("Magicka", Game.GetPlayer().GetAV("Magicka"))
			If(aaaSusanooTransitionGlobal.GetValue() == 1)
				aaaSusanoStage1Spell.Cast(Game.GetPlayer(), none)
			ElseIf(aaaSusanooTransitionGlobal.GetValue() == 2)
				aaaSusanoStage2Spell.Cast(Game.GetPlayer(), none)
			ElseIf(aaaSusanooTransitionGlobal.GetValue() == 3)
				aaaSusanoStage3Spell.Cast(Game.GetPlayer(), none)
			ElseIf(aaaSusanooTransitionGlobal.GetValue() == 4)
				aaaSusanoStage4Spell.Cast(Game.GetPlayer(), none)
			EndIf
		EndIf
;======================================================================================;
;  END
;=============;
	EndIf
EndIf
EndEvent